---
title: CanvasRenderingContext2D.translate()
slug: Web/API/CanvasRenderingContext2D/translate
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.translate()</code></strong> method of the Canvas 2D API adds a translation transformation to the current matrix.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.translate(<em>x</em>, <em>y</em>);
</pre>

<p>The <code>translate()</code> method adds a translation transformation to the current matrix by moving the canvas and its origin <code>x</code> units horizontally and <code>y</code> units vertically on the grid.</p>

<p><img alt="" class="internal" src="https://mdn.mozillademos.org/files/234/Canvas_grid_translate.png" style="float: right;"></p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>x</code></dt>
 <dd>Distance to move in the horizontal direction. Positive values are to the right, and negative to the left.</dd>
 <dt><code>y</code></dt>
 <dd>Distance to move in the vertical direction. Positive values are down, and negative are up.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Moving_a_shape">Moving a shape</h3>

<p>This example draws a square that is moved from its default position by the <code>translate()</code> method. An unmoved square of the same size is then drawn for comparison.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The <code>translate()</code> method translates the context by 110 horizontally and 30 vertically. The first square is shifted by those amounts from its default position.</p>

<pre class="brush: js; highlight:[5]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Moved square
ctx.translate(110, 30);
ctx.fillStyle = 'red';
ctx.fillRect(0, 0, 80, 80);

// Reset current transformation matrix to the identity matrix
ctx.setTransform(1, 0, 0, 1, 0, 0);

// Unmoved square
ctx.fillStyle = 'gray';
ctx.fillRect(0, 0, 80, 80);
</pre>

<h4 id="Result">Result</h4>

<p>The <span style="color: red;">moved square is red</span>, and the <span style="color: gray;">unmoved square is gray</span>.</p>

<p>{{ EmbedLiveSample('Moving_a_shape', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-translate", "CanvasRenderingContext2D.translate")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.translate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
</ul>
